<?php
/**
 * InlineObject24
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineObject24 Class Doc Comment
 *
 * @category Class
 * @description Defines a callback
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineObject24 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_object_24';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'fromEmployeeId' => 'int',
        'toEmployeeId' => 'int',
        'toDepartmentId' => 'int',
        'date' => 'int',
        'companyId' => 'int',
        'companyName' => 'string',
        'employeeId' => 'int',
        'employeeName' => 'string',
        'phoneNumber' => 'string',
        'info' => 'string',
        'state' => 'string',
        'priority' => 'int',
        'callbackAfterTime' => 'int',
        'callbackUntilTime' => 'int',
        'linkTypeId' => 'int',
        'linkId' => 'int'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'fromEmployeeId' => null,
        'toEmployeeId' => null,
        'toDepartmentId' => null,
        'date' => 'timestamp',
        'companyId' => null,
        'companyName' => null,
        'employeeId' => null,
        'employeeName' => null,
        'phoneNumber' => null,
        'info' => null,
        'state' => null,
        'priority' => null,
        'callbackAfterTime' => 'timestamp',
        'callbackUntilTime' => 'timestamp',
        'linkTypeId' => null,
        'linkId' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'fromEmployeeId' => 'fromEmployeeId',
        'toEmployeeId' => 'toEmployeeId',
        'toDepartmentId' => 'toDepartmentId',
        'date' => 'date',
        'companyId' => 'companyId',
        'companyName' => 'companyName',
        'employeeId' => 'employeeId',
        'employeeName' => 'employeeName',
        'phoneNumber' => 'phoneNumber',
        'info' => 'info',
        'state' => 'state',
        'priority' => 'priority',
        'callbackAfterTime' => 'callbackAfterTime',
        'callbackUntilTime' => 'callbackUntilTime',
        'linkTypeId' => 'linkTypeId',
        'linkId' => 'linkId'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'fromEmployeeId' => 'setFromEmployeeId',
        'toEmployeeId' => 'setToEmployeeId',
        'toDepartmentId' => 'setToDepartmentId',
        'date' => 'setDate',
        'companyId' => 'setCompanyId',
        'companyName' => 'setCompanyName',
        'employeeId' => 'setEmployeeId',
        'employeeName' => 'setEmployeeName',
        'phoneNumber' => 'setPhoneNumber',
        'info' => 'setInfo',
        'state' => 'setState',
        'priority' => 'setPriority',
        'callbackAfterTime' => 'setCallbackAfterTime',
        'callbackUntilTime' => 'setCallbackUntilTime',
        'linkTypeId' => 'setLinkTypeId',
        'linkId' => 'setLinkId'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'fromEmployeeId' => 'getFromEmployeeId',
        'toEmployeeId' => 'getToEmployeeId',
        'toDepartmentId' => 'getToDepartmentId',
        'date' => 'getDate',
        'companyId' => 'getCompanyId',
        'companyName' => 'getCompanyName',
        'employeeId' => 'getEmployeeId',
        'employeeName' => 'getEmployeeName',
        'phoneNumber' => 'getPhoneNumber',
        'info' => 'getInfo',
        'state' => 'getState',
        'priority' => 'getPriority',
        'callbackAfterTime' => 'getCallbackAfterTime',
        'callbackUntilTime' => 'getCallbackUntilTime',
        'linkTypeId' => 'getLinkTypeId',
        'linkId' => 'getLinkId'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const STATE_UNSEEN = 'UNSEEN';
    public const STATE__NEW = 'NEW';
    public const STATE_NOBODY_ANSWERED = 'NOBODY_ANSWERED';
    public const STATE_BUSY = 'BUSY';
    public const STATE_NOT_PRESENT = 'NOT_PRESENT';
    public const STATE_NEW_CALLBACK_REENTERED = 'NEW_CALLBACK_REENTERED';
    public const STATE_COMPLETED = 'COMPLETED';
    public const STATE_EXPECTED_CALLBACK = 'EXPECTED_CALLBACK';
    public const STATE_EXPECTED_CALLBACK_COMPLETED = 'EXPECTED_CALLBACK_COMPLETED';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStateAllowableValues()
    {
        return [
            self::STATE_UNSEEN,
            self::STATE__NEW,
            self::STATE_NOBODY_ANSWERED,
            self::STATE_BUSY,
            self::STATE_NOT_PRESENT,
            self::STATE_NEW_CALLBACK_REENTERED,
            self::STATE_COMPLETED,
            self::STATE_EXPECTED_CALLBACK,
            self::STATE_EXPECTED_CALLBACK_COMPLETED,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['fromEmployeeId'] = $data['fromEmployeeId'] ?? null;
        $this->container['toEmployeeId'] = $data['toEmployeeId'] ?? null;
        $this->container['toDepartmentId'] = $data['toDepartmentId'] ?? null;
        $this->container['date'] = $data['date'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['companyName'] = $data['companyName'] ?? null;
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['employeeName'] = $data['employeeName'] ?? null;
        $this->container['phoneNumber'] = $data['phoneNumber'] ?? null;
        $this->container['info'] = $data['info'] ?? null;
        $this->container['state'] = $data['state'] ?? null;
        $this->container['priority'] = $data['priority'] ?? null;
        $this->container['callbackAfterTime'] = $data['callbackAfterTime'] ?? null;
        $this->container['callbackUntilTime'] = $data['callbackUntilTime'] ?? null;
        $this->container['linkTypeId'] = $data['linkTypeId'] ?? null;
        $this->container['linkId'] = $data['linkId'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getStateAllowableValues();
        if (!is_null($this->container['state']) && !in_array($this->container['state'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'state', must be one of '%s'",
                $this->container['state'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets fromEmployeeId
     *
     * @return int|null
     */
    public function getFromEmployeeId()
    {
        return $this->container['fromEmployeeId'];
    }

    /**
     * Sets fromEmployeeId
     *
     * @param int|null $fromEmployeeId Defines the employee who entered the callback
     *
     * @return self
     */
    public function setFromEmployeeId($fromEmployeeId)
    {
        $this->container['fromEmployeeId'] = $fromEmployeeId;

        return $this;
    }

    /**
     * Gets toEmployeeId
     *
     * @return int|null
     */
    public function getToEmployeeId()
    {
        return $this->container['toEmployeeId'];
    }

    /**
     * Sets toEmployeeId
     *
     * @param int|null $toEmployeeId The callback is assigned to this employee (This person has to do the call)
     *
     * @return self
     */
    public function setToEmployeeId($toEmployeeId)
    {
        $this->container['toEmployeeId'] = $toEmployeeId;

        return $this;
    }

    /**
     * Gets toDepartmentId
     *
     * @return int|null
     */
    public function getToDepartmentId()
    {
        return $this->container['toDepartmentId'];
    }

    /**
     * Sets toDepartmentId
     *
     * @param int|null $toDepartmentId Callbacks can be assigned to a special department. Every employee of this department sees the callback.
     *
     * @return self
     */
    public function setToDepartmentId($toDepartmentId)
    {
        $this->container['toDepartmentId'] = $toDepartmentId;

        return $this;
    }

    /**
     * Gets date
     *
     * @return int|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param int|null $date The callback was created on this date
     *
     * @return self
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId Here, the id of the company is given which has to be called back
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets companyName
     *
     * @return string|null
     */
    public function getCompanyName()
    {
        return $this->container['companyName'];
    }

    /**
     * Sets companyName
     *
     * @param string|null $companyName same as \"companyId\", but here a string can be given (i.e. if the company wasn't created yet in TANSS)
     *
     * @return self
     */
    public function setCompanyName($companyName)
    {
        $this->container['companyName'] = $companyName;

        return $this;
    }

    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId Here, the id of the employee is given (who has to be called back)
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets employeeName
     *
     * @return string|null
     */
    public function getEmployeeName()
    {
        return $this->container['employeeName'];
    }

    /**
     * Sets employeeName
     *
     * @param string|null $employeeName same as \"employeeId\", but here a string can be given (i.e. if the employee wasn't created yet in TANSS)
     *
     * @return self
     */
    public function setEmployeeName($employeeName)
    {
        $this->container['employeeName'] = $employeeName;

        return $this;
    }

    /**
     * Gets phoneNumber
     *
     * @return string|null
     */
    public function getPhoneNumber()
    {
        return $this->container['phoneNumber'];
    }

    /**
     * Sets phoneNumber
     *
     * @param string|null $phoneNumber You must define the phone number here
     *
     * @return self
     */
    public function setPhoneNumber($phoneNumber)
    {
        $this->container['phoneNumber'] = $phoneNumber;

        return $this;
    }

    /**
     * Gets info
     *
     * @return string|null
     */
    public function getInfo()
    {
        return $this->container['info'];
    }

    /**
     * Sets info
     *
     * @param string|null $info (Optional) Further information regarding the callback
     *
     * @return self
     */
    public function setInfo($info)
    {
        $this->container['info'] = $info;

        return $this;
    }

    /**
     * Gets state
     *
     * @return string|null
     */
    public function getState()
    {
        return $this->container['state'];
    }

    /**
     * Sets state
     *
     * @param string|null $state Describes a current \"state\" of a callback
     *
     * @return self
     */
    public function setState($state)
    {
        $allowedValues = $this->getStateAllowableValues();
        if (!is_null($state) && !in_array($state, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'state', must be one of '%s'",
                    $state,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['state'] = $state;

        return $this;
    }

    /**
     * Gets priority
     *
     * @return int|null
     */
    public function getPriority()
    {
        return $this->container['priority'];
    }

    /**
     * Sets priority
     *
     * @param int|null $priority priority of the callback from 1 (lowest) to 9 (highest)
     *
     * @return self
     */
    public function setPriority($priority)
    {
        $this->container['priority'] = $priority;

        return $this;
    }

    /**
     * Gets callbackAfterTime
     *
     * @return int|null
     */
    public function getCallbackAfterTime()
    {
        return $this->container['callbackAfterTime'];
    }

    /**
     * Sets callbackAfterTime
     *
     * @param int|null $callbackAfterTime If the callback has to be \"later\" than a specific time, give here the minimum date for the callback
     *
     * @return self
     */
    public function setCallbackAfterTime($callbackAfterTime)
    {
        $this->container['callbackAfterTime'] = $callbackAfterTime;

        return $this;
    }

    /**
     * Gets callbackUntilTime
     *
     * @return int|null
     */
    public function getCallbackUntilTime()
    {
        return $this->container['callbackUntilTime'];
    }

    /**
     * Sets callbackUntilTime
     *
     * @param int|null $callbackUntilTime If the callback has to be processed before a given date, specify this \"latest\" date here
     *
     * @return self
     */
    public function setCallbackUntilTime($callbackUntilTime)
    {
        $this->container['callbackUntilTime'] = $callbackUntilTime;

        return $this;
    }

    /**
     * Gets linkTypeId
     *
     * @return int|null
     */
    public function getLinkTypeId()
    {
        return $this->container['linkTypeId'];
    }

    /**
     * Sets linkTypeId
     *
     * @param int|null $linkTypeId If the callback is assigned to a ticket (or other assignment), linkType is given here
     *
     * @return self
     */
    public function setLinkTypeId($linkTypeId)
    {
        $this->container['linkTypeId'] = $linkTypeId;

        return $this;
    }

    /**
     * Gets linkId
     *
     * @return int|null
     */
    public function getLinkId()
    {
        return $this->container['linkId'];
    }

    /**
     * Sets linkId
     *
     * @param int|null $linkId If the callback is assigned to a ticket (or other assignment), the id is given here
     *
     * @return self
     */
    public function setLinkId($linkId)
    {
        $this->container['linkId'] = $linkId;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


